﻿using Infragistics.Controls.Grids;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XGEdititableCellsSL
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            xg.DataContext = Data.GetData(1, 1, 10);
            xg2.DataContext = Data1.GetData(5, 1, 5);
        }
        private void xg_CellEnteredEditMode(object sender, EditingCellEventArgs e)
        {
            if (e.Cell.Column.Key.ToString() == "Label")
            {
                foreach (var row in xg2.Rows)
                {
                    foreach (var cell in row.Cells)
                    {
                        if (cell.Column.Key.ToString() == "Label")
                        {
                            if (row.Index < 2)
                            {
                                (row.Data as Data).Label = e.Cell.Value.ToString();
                                (cell.Control as CellControl).IsEnabled = true;
                            }
                        }
                    }
                }
            }
        }

        private void xg_CellExitedEditMode(object sender, CellExitedEditingEventArgs e)
        {
            if (e.Cell.Column.Key.ToString() == "Label")
            {
                foreach (var row in xg2.Rows)
                {
                    foreach (var cell in row.Cells)
                    {
                        if (cell.Column.Key.ToString() == "Label")
                        {
                            if (row.Index < 2)
                            {
                                (row.Data as Data).Label = e.Cell.Value.ToString();
                            }
                        }
                    }
                }
            }
        }
    }
    public class Data : INotifyPropertyChanged
    {
        private int high;
        private int value;
        private string label;

        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public int High
        {
            get { return high; }
            set
            {
                high = value;
                PropChanged("High");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Label = "Item " + i,
                    High = r.Next(rangeStart, rangeEnd),
                    Value = r.Next(rangeStart, rangeEnd)
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class Data1 : INotifyPropertyChanged
    {
        private int high;
        private int value;
        private string label;

        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public int High
        {
            get { return high; }
            set
            {
                high = value;
                PropChanged("High");
            }
        }

        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Label = "Item " + r.Next(1,1000),
                    High = r.Next(rangeStart, rangeEnd),
                    Value = r.Next(rangeStart, rangeEnd)
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
